//+------------------------------------------------------------------+
//|                                   MTF_BrainTrend1-all-in-one.mq4 |
//|                                     BrainTrading Inc. System 7.0 |
//|                                      http://www.braintrading.com |
//|                             Modified by Serge skhorouji@gmail.com|     
//+------------------------------------------------------------------+
/* Serge: This indicator includes all 4 original BrainTrend1 indicators as I am 2 lazy to apply 
   them all one by one on a chart:
   BrainTrend1Stop, BrainTrend1StopLine, BrainTrend1Sig, TrainTrend1.
   It has customised external variables that can be played with during optimisation
   Also I renamed variables, simplified & logically re-arranged the codes of the original indicators 
   to make them more understandable (I mean for myself :-)
*/   

#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.braintrading.comt"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Magenta
#property indicator_color2 Aqua
#property indicator_color3 Magenta
#property indicator_color4 Aqua
#property indicator_color5 Magenta
#property indicator_color6 Aqua
#property indicator_color7 Magenta
#property indicator_color8 Aqua

//---- input parameters
extern   int       TimeFrame= 0;
extern   double    stoch_period=9;
extern   double    stoch_max=53;
extern   double    stoch_min=47;
extern   double    atr_current_norm_factor=0.435;
extern   double    atr_before_norm_factor=1.5;
extern   double    atr_period=7;
extern   int       atr_before_step=1;
extern   int       AlertMode = 0; //0-off,1-warning mode,2-alert mode  
extern   int       NumBars=100;   //If you want to display ALL indicator values, set this to 0 - will use more memory of cause

//---- buffers
double sell_stop_dot_buf[];   //Sell stop dots, aka BrainTrend1Stop
double buy_stop_dot_buf[];    //Buy stop dots
double sell_stop_line_buf[];  //Sell stop line
double buy_stop_line_buf[];   //Buy stop line
double sell_signal_buf[];     //Sell signal dots
double buy_signal_buf[];      //Buy signal dots
double down_buf[];            //Down trend bars
double up_buf[];              //Up trend bars 

int init()
{  SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,115);
   SetIndexBuffer(0,sell_stop_dot_buf);
   SetIndexLabel(0,"sell_stop_dot");
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,115);
   SetIndexBuffer(1,buy_stop_dot_buf);
   SetIndexLabel(1,"buy_stop_dot");
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,sell_stop_line_buf);
   SetIndexLabel(2,"sell_stop_line");
   SetIndexEmptyValue(2, EMPTY_VALUE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,buy_stop_line_buf);
   SetIndexLabel(3,"buy_stop_line");
   SetIndexEmptyValue(3, EMPTY_VALUE);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,108);
   SetIndexBuffer(4,sell_signal_buf);
   SetIndexLabel(4,"sell_signal");
   SetIndexEmptyValue(4, EMPTY_VALUE);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,108);
   SetIndexBuffer(5,buy_signal_buf);
   SetIndexLabel(5,"buy_signal");
   SetIndexEmptyValue(5, EMPTY_VALUE);
   SetIndexStyle(6,DRAW_HISTOGRAM);
   SetIndexBuffer(6,down_buf);
   SetIndexLabel(6,"down_trend");
   SetIndexStyle(7,DRAW_HISTOGRAM);
   SetIndexBuffer(7,up_buf);
   SetIndexLabel(7,"up_trend");

}

int start()
{  
   int    shift,limit,y,counted_bars=IndicatorCounted();
     
   limit=Bars-counted_bars+TimeFrame/Period();
 
   for(shift=0,y=0;shift<limit;shift++)
   {
   if (Time[shift]<iTime(NULL,TimeFrame,y)) y++; 
      if(y<=NumBars)
      {
      sell_signal_buf[shift]=iCustom(NULL,TimeFrame,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,atr_before_norm_factor,atr_period,atr_before_step,AlertMode,NumBars,4,y);
      sell_stop_dot_buf[shift]=iCustom(NULL,TimeFrame,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,atr_before_norm_factor,atr_period,atr_before_step,AlertMode,NumBars,0,y);
      sell_stop_line_buf[shift]=sell_stop_dot_buf[shift];
      
      buy_signal_buf[shift]=iCustom(NULL,TimeFrame,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,atr_before_norm_factor,atr_period,atr_before_step,AlertMode,NumBars,5,y);
      buy_stop_dot_buf[shift]=iCustom(NULL,TimeFrame,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,atr_before_norm_factor,atr_period,atr_before_step,AlertMode,NumBars,1,y);
      buy_stop_line_buf[shift]=buy_stop_dot_buf[shift];
      
      double up = iCustom(NULL,TimeFrame,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,atr_before_norm_factor,atr_period,atr_before_step,AlertMode,NumBars,7,y);
      double dn = iCustom(NULL,TimeFrame,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,atr_before_norm_factor,atr_period,atr_before_step,AlertMode,NumBars,6,y);
      
      if(up>dn && up!=EMPTY_VALUE) {up_buf[shift]=High[shift]; down_buf[shift] = Low[shift];} 
      else
      if(dn>up && dn!=EMPTY_VALUE) {down_buf[shift]=High[shift]; up_buf[shift] = Low[shift];} 
      
      }
   }  
}